Redmine - Feature #29208

Support email addresses with IDN (internationalized domain names) in user accounts
2018-07-07 09:01 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: 118n Estimated time: 0.00 hour
Target version: 6.0.0

Resolution: Fixed

Description

This is a patch to add IDN (internationalized domain names) support to email addresses of user accounts.

Currently, Redmine does not accept IDN email addresses like "joe@U00000.jp" and its ASCII expression
joe@xn--eckwd4c7cu47r2wi.jp" when creating/updating a user account. After applying this patch, both expressions will be accepted.

According to IDN World Report, there are approx 8.7 millions IDNs in the world as of December 2016, and those are used in many
countries. To support IDN email addresses should be beneficial for many people.

This patch converts Unicode domain names to traditional ASCII domain names just before saving an email address. However, it
does not convert ASCII domain names to Unicode domain names when displaying email address. Users will see ASCII expression "
joe@xn--eckwd4c7cud7r2wt.jp" on my_account page even if they have entered Unicode email address "joe@U00000.jp".

This approach can minimize the change to existing code and works fine with IDN-unaware MTAs and plugins while allowing people
to use IDN email addresses.

"Email" field accepts Unicode domain names:

My account
Information Ermail notificy
First name * padmine
Faor any event g
Last name * :
Admin I don't w4
Email * jpea A 228 ip rmyself
Language | English <]
Preferences
Phone number
Hide my ¢
Money
Save Displ3
Warn me wi

ASCII converted email address is shown after saving:
https://idnworldreport.eu/maps/idn-world-map/
https://idnworldreport.eu/maps/idn-world-map/
¥ Account was successfully updated.

My account

Information Email notifica

First name * pednine
Far any event g

Last name * gqin

I don't w3
Email * joe@xn--eckwddcFoud7riwt. J myself
Language | gngiish (¥
Preferences

Phone number

Hide my ¢
Money

Save Disply

Warn me wi

References:

o |IDN World Report — Official World Report on Internationalised Domain Names
e Punycoder - the Punycode converter (IDN converter)

Related issues:

Related to Redmine - Defect #28878: Email does not support Russian-language d... Closed
Related to Redmine - Defect #15985: Email address with non-ASCII character ca... Closed
Related to Redmine - Defect #32793: Email address with Punycode top-level dom... Closed

Associated revisions

Revision 22667 - 2024-02-01 09:46 - Go MAEDA

Add support for IDN (internationalized domain name) email addresses in user accounts (#29208).

Patch by Go MAEDA (@maeda).

Revision 23064 - 2024-09-20 03:58 - Go MAEDA

Replace custom email normalization logic with Rails' ‘normalizes™ method (#29208).

History

#1 - 2018-07-07 09:06 - Go MAEDA
- Related to Defect #28878: Email does not support Russian-language domains. added

#2 - 2018-07-07 09:24 - Go MAEDA

- Related to Defect #15985: Email address with non-ASCII character causes delivery error added

#3 - 2018-07-07 09:28 - Go MAEDA
- File support-idn-email-addresses-v2.diff added

Fixed unnecessary Punycode conversion when an invalid email address is entered.

#4 - 2018-07-07 10:00 - Go MAEDA
- File support-idn-email-addresses-v3.diff added

Removed unnecessary "require 'simpleidn™.

#5 - 2018-07-08 07:40 - Go MAEDA
- File support-idn-email-addresses-v4.diff added
Updated the patch.

e Simplified the code by replacing String#rpartition with String#partition.
e Added tests to make sure that local-part is not encoded with Punycode.

#6 - 2018-07-09 15:15 - Go MAEDA

- Target version set to 4.1.0

As we can see in #28878, there are already people who are in trouble because of lack of internationalized domain name support. | think that more
and more people will start using email addresses with IDN. Let's deliver this feature in the next major release.

#7 - 2018-09-15 11:01 - Go MAEDA
- File 0001-Allow-Punycode-in-email-addresses.patch added
- File 0002-Support-IDN-email-addresses.patch added

| divided support-idn-email-addresses-v4.diff into two patches. The first one changes only the regular expression to allow Punycode in email
addresses. The second one supports email addresses which include Unicode characters in the domain names.

| think that Redmine should support Punycode at least. If 0001-Allow-Punycode-in-email-addresses.patch is merged, a user who has uses an email
address "joe@l00000.jp" can make his account on Redmine by spelling his email address as "joe@xn--eckwd4c7cu47r2wf.jp".

#8 - 2018-09-16 03:15 - Go MAEDA
- File deleted (0001-Allow-Punycode-in-email-addresses.patch)

#9 - 2018-09-16 03:16 - Go MAEDA
- File 0001-Allow-Punycode-in-email-addresses.patch added

Improved the regular expression for email addresses.

#10 - 2019-04-11 09:49 - Go MAEDA

- Target version changed from 4.1.0 to Candidate for next major release

It seems that no one is interested in this feature. Maybe this feature does not worth adding a gem for now.

#11 - 2020-01-13 06:30 - Go MAEDA
- Related to Defect #32793: Email address with Punycode top-level domain is not accepted added

#12 - 2024-01-27 10:24 - Go MAEDA
Go MAEDA wrote in #note-10:

It seems that no one is interested in this feature. Maybe this feature does not worth adding a gem for now.

We can add this feature without adding an extra gem because Addressable gem already used in Redmine supports Puny code conversion.

$ bin/rails c

Loading development environment (Rails 7.1.2)
irb(main) : 001> Addressable::IDNA.to_ascii ('000000.3jp")
=> "xn--eckwd4c7cud7r2wf. jp"

#13 - 2024-01-28 05:36 - Go MAEDA
- File 29208.patch added

- Subject changed from IDN support for email addresses of user accounts to Support email addresses with internationalized domain names in user
accounts

| have updated the patch to support email addresses with an internationalized domain name (IDN). This new patch uses an already loaded
Addressable gem instead of adding a new gem to decode internationalized domain names.

#14 - 2024-01-29 03:23 - Go MAEDA

- Subject changed from Support email addresses with internationalized domain names in user accounts to Support email addresses with IDN
(internationalized domain names) in user accounts

- Category changed from Accounts / authentication to 118n
- Target version changed from Candidate for next major release to 6.0.0

Setting the target version to 6.0.0.

#15 - 2024-02-01 09:47 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch in r22667.

#16 - 2024-08-12 12:42 - Go MAEDA
- File 29208-utilize-normalize.patch added

- Status changed from Closed to Reopened

The attached patch replaces the custom setter address= with the normalizes, introduced in Rails 7.1.

#17 - 2024-09-20 03:58 - Go MAEDA

- Status changed from Reopened to Closed

Go MAEDA wrote in #note-16:

The attached patch replaces the custom setter address= with the normalizes, introduced in Rails 7.1.

Committed the change in r23064.

Files

idn-support-screenshot-1.png 25.9 KB 2018-07-07 Go MAEDA
support-idn-email-addresses-v4.diff 2.13 KB 2018-07-08 Go MAEDA
0002-Support-IDN-email-addresses.patch 1.95 KB 2018-09-15 Go MAEDA
